      subroutine moldy(isteps,tbath)
c perform isteps integrations of newtons equations with time step
c tau. if tbath gt. 0 will add a random force and viscous drag
c to simulate the langevin equation with a friction coefficent
c equal to 1/(beta dconstant * tbath *mass)
      implicit real*8 (a-h,o-z)
      include 'syscon.cm'
      real*8 totmom(3),df(3)
      include 'caver.cm'
      include 'cunits.cm'
      include 'syspec.cm'
      include 'blank.cm'

c intialize bins for averages the first time through

      if(jmdent.eq.0) then
      data jmdent/0/
      call setav(jmdent,'MD_EN',uname(1),1)
      call setav(jmdke,'MD_KE',uname(1),1)
      call setav(jmdpe,'MD_PE',uname(1),1)
      call setav(jmom2,'MOM^2',uname(1),1)
      call setav(jmdext,'MD_xtd',uname(1),1)
      if(ifply.ne.0)call setav(jmdvbd,'MD_PP',uname(1),1)!polymer bonding potential 
      endif

      if(vcurrent.eq.0) then ! initialize velocity and force if needed
       call maxbol
       chi=0.d0 ! initialize friction constant
       chiint=0.d0 ! time integral of friction constant
       vcurrent=1
      endif
       call force(lxold,vtotal,vbond)

! on entry xold=old position, velo =old velocity, force = old force

      do ipass=1,isteps  ! begin loop over steps

      ic=0
      ekine=0.0d0 ! initialize
      do i=1,natoms ! move the particles
      itype=icc(ltype+i)
      tau2m=0.5d0*tau*cc(lmassiv+i)
      do l=1,ndim
         ic=ic+1
         acc=tau2m*cc(lforce+ic)-0.5d0*tau*chi*cc(lvelo+ic)
         r=cc(lxold+ic)+tau*(cc(lvelo+ic)+acc) !eq 3.19a
!         r=mod(r+el2(l),ell(l))-el2(l)  ! apply pbc

! pbc
         if(r.gt.el2(l))r=r-ell(l)
         if(r.lt.-el2(l))r=r+ell(l)

         cc(lxold+ic)=r
         cc(lvelo+ic)=cc(lvelo+ic)+ acc        !eq 3.20
         ekine=ekine+cc(lmass+itype)*cc(lvelo+ic)**2
      enddo
      enddo

      etotal=vtotal+0.5d0*ekine ! this is for the old step
      avtemp(jmdent)=avtemp(jmdent)+etotal
      avtemp(jmdke)=avtemp(jmdke)+0.5d0*ekine
      avtemp(jmdpe)=avtemp(jmdpe)+vtotal
      if(ifply.ne.0) avtemp(jmdvbd)=avtemp(jmdvbd)+vbond


      call force(lxold,vtotal,vbond) ! get force on all the particles

      avtemp(jmdext)=avtemp(jmdext)+etotal+ndim*temp*natoms*chiint
      if(heatmass.ne.0.d0)avtemp(jmdext)=avtemp(jmdext)+
     . (ndim*natoms*temp)*chi**2/(2.d0*heatmass)
      chiint=chiint+0.5d0*tau*chi
      chi=chi+heatmass*tau*(ekine/(natoms*ndim*temp)-1.d0)! advance friction coefficent
      chiint=chiint+0.5d0*tau*chi
      factor=1.d0/(1.d0+chi*0.5d0*tau)

      do l=1,ndim
           totmom(l)=0.0d0
      enddo

      ic=0
      do i=1,natoms 
      itype=icc(ltype+i)
      am=cc(lmass+itype)
      tau2m=0.5d0*tau*cc(lmassiv+i)
      do l=1,ndim
         ic=ic+1
         cc(lvelo+ic)=factor*(cc(lvelo+ic)+tau2m*cc(lforce+ic))         !eq 3.21
         totmom(l)=totmom(l)+am*cc(lvelo+ic)
      enddo
      enddo


      do l=1,ndim
           avtemp(jmom2)=avtemp(jmom2)+totmom(l)**2
      enddo
      call averages

      enddo ! end of this block

      ant=float(isteps*natoms) ! add to normalization of averages
      anorm(jmdent)=anorm(jmdent)+ant
      anorm(jmdext)=anorm(jmdext)+ant
      anorm(jmom2)=anorm(jmom2)+isteps
      anorm(jmdpe)=anorm(jmdpe)+ant
      anorm(jmdke)=anorm(jmdke)+ant
      if(ifply.ne.0) anorm(jmdvbd)=anorm(jmdvbd)+isteps
      return
      end

!     call caches(lamma,ntypes,'vbondd',1)
!     if(tbath.ne.0.0d0) then ! calculate step relaxation times for langevin dynamics
!       do  it=1,ntypes
!       cc(lamma+it)=tau/(tbath*cc(ldcnst+it)*beta*cc(lmass+it))
!       enddo
!     endif
!     if(tbath.gt.0.0d0) then ! for langevin equation get random force
!        ranfor=2.d0*taumi*cc(lamma+itype)/beta
!        call gauran(ranfor,df,ndim)
!        cbath=1.0d0/(1.0d0+.5d0*cc(lamma+itype))
!     endif
!        if(tbath.gt.0.0d0) then ! for langevin equation add random forces
!           velo=cbath*(velo+taui2*df(l))
!           f=f+df(l)-tau*cc(lamma+itype)*velo
!        endif
